



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>深入研究java.lang.ThreadLocal类(转)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">深入研究java.lang.ThreadLocal类(转)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 15:53:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>引用：http://lavasoft.blog.51cto.com/62575/51926/</p>
<div><strong>一、概述</strong></div>
<div>&nbsp;</div>
<div>ThreadLocal是什么呢？其实ThreadLocal并非是一个线程的本地实现版本，它并不是一个Thread，而是threadlocalvariable(线程局部变量)。也许把它命名为ThreadLocalVar更加合适。线程局部变量(ThreadLocal)其实的功用非常简单，就是为每一个使用该变量的线程都提供一个变量值的副本，是Java中一种较为特殊的线程绑定机制，是每一个线程都可以独立地改变自己的副本，而不会和其它线程的副本冲突。</div>
<div>&nbsp;</div>
<div>从线程的角度看，每个线程都保持一个对其线程局部变量副本的隐式引用，只要线程是活动的并且 ThreadLocal 实例是可访问的；在线程消失之后，其线程局部实例的所有副本都会被垃圾回收（除非存在对这些副本的其他引用）。</div>
<div>&nbsp;</div>
<div>通过ThreadLocal存取的数据，总是与当前线程相关，也就是说，JVM 为每个运行的线程，绑定了私有的本地实例存取空间，从而为多线程环境常出现的并发访问问题提供了一种隔离机制。</div>
<div>&nbsp;</div>
<div>ThreadLocal是如何做到为每一个线程维护变量的副本的呢？其实实现的思路很简单，在ThreadLocal类中有一个Map，用于存储每一个线程的变量的副本。</div>
<div>&nbsp;</div>
<div>概括起来说，对于多线程资源共享的问题，同步机制采用了&ldquo;以时间换空间&rdquo;的方式，而ThreadLocal采用了&ldquo;以空间换时间&rdquo;的方式。前者仅提供一份变量，让不同的线程排队访问，而后者为每一个线程都提供了一份变量，因此可以同时访问而互不影响。</div>
<div>&nbsp;</div>
<div><strong>二、API说明</strong></div>
<div>&nbsp;</div>
<div>ThreadLocal()</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 创建一个线程本地变量。</div>
<div>&nbsp;</div>
<div>T get()</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 返回此线程局部变量的当前线程副本中的值，如果这是线程第一次调用该方法，则创建并初始化此副本。</div>
<div>&nbsp;</div>
<div>protected&nbsp; T initialValue()</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 返回此线程局部变量的当前线程的初始值。最多在每次访问线程来获得每个线程局部变量时调用此方法一次，即线程第一次使用 get() 方法访问变量的时候。如果线程先于 get 方法调用 set(T) 方法，则不会在线程中再调用 initialValue 方法。</div>
<div>&nbsp;</div>
<div>&nbsp;&nbsp; 若该实现只返回 null；如果程序员希望将线程局部变量初始化为 null 以外的某个值，则必须为 ThreadLocal 创建子类，并重写此方法。通常，将使用匿名内部类。initialValue 的典型实现将调用一个适当的构造方法，并返回新构造的对象。</div>
<div>&nbsp;</div>
<div>void remove()</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 移除此线程局部变量的值。这可能有助于减少线程局部变量的存储需求。如果再次访问此线程局部变量，那么在默认情况下它将拥有其 initialValue。</div>
<div>&nbsp;</div>
<div>void set(T value)</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 将此线程局部变量的当前线程副本中的值设置为指定值。许多应用程序不需要这项功能，它们只依赖于 initialValue() 方法来设置线程局部变量的值。</div>
<div>&nbsp;</div>
<div>在程序中一般都重写initialValue方法，以给定一个特定的初始值。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div><strong>三、典型实例</strong></div>
<div>&nbsp;</div>
<div>1、Hiberante的Session 工具类HibernateUtil</div>
<div>这个类是Hibernate官方文档中HibernateUtil类，用于session管理。</div>
<div>&nbsp;</div>
<div>
<div>
<div>
<div>public class HibernateUtil {</div>
<div>&nbsp;&nbsp;&nbsp; private static Log log = LogFactory.getLog(HibernateUtil.class);</div>
<div>&nbsp;&nbsp;&nbsp; private static final SessionFactory sessionFactory;&nbsp;&nbsp;&nbsp;&nbsp; //定义SessionFactory</div>
<div>&nbsp;</div>
<div>&nbsp;&nbsp;&nbsp; static {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; try {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; // 通过默认配置文件hibernate.cfg.xml创建SessionFactory<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; sessionFactory = new Configuration().configure().buildSessionFactory();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; } catch (Throwable ex) {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; log.error("初始化SessionFactory失败！", ex);<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; throw new ExceptionInInitializerError(ex);<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp; }</div>
<div>&nbsp;&nbsp;&nbsp; //创建线程局部变量session，用来保存Hibernate的Session<br />&nbsp;&nbsp;&nbsp; public static final ThreadLocal session = new ThreadLocal();</div>
<div>&nbsp;</div>
<div>&nbsp;&nbsp;&nbsp; /**<br />&nbsp;&nbsp;&nbsp;&nbsp; * 获取当前线程中的Session<br />&nbsp;&nbsp;&nbsp;&nbsp; * @return Session<br />&nbsp;&nbsp;&nbsp;&nbsp; * @throws HibernateException<br />&nbsp;&nbsp;&nbsp;&nbsp; */<br />&nbsp;&nbsp;&nbsp; public static Session currentSession() throws HibernateException {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Session s = (Session) session.get();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; // 如果Session还没有打开，则新开一个Session<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if (s == null) {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; s = sessionFactory.openSession();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; session.set(s);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; //将新开的Session保存到线程局部变量中<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; return s;<br />&nbsp;&nbsp;&nbsp; }</div>
<div>&nbsp;</div>
<div>&nbsp;&nbsp;&nbsp; public static void closeSession() throws HibernateException {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; //获取线程局部变量，并强制转换为Session类型<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Session s = (Session) session.get();<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; session.set(null);<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if (s != null)<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; s.close();<br />&nbsp;&nbsp;&nbsp; }<br />}</div>
</div>
</div>
</div>
<div>&nbsp;</div>
<div>在这个类中，由于没有重写ThreadLocal的initialValue()方法，则首次创建线程局部变量session其初始值为null，第一次调用currentSession()的时候，线程局部变量的get()方法也为null。因此，对session做了判断，如果为null，则新开一个Session，并保存到线程局部变量session中，这一步非常的关键，这也是&ldquo;public static final ThreadLocal session = new ThreadLocal()&rdquo;所创建对象session能强制转换为Hibernate Session对象的原因。</div>
<div>&nbsp;</div>
<div>2、另外一个实例</div>
<div>创建一个Bean，通过不同的线程对象设置Bean属性，保证各个线程Bean对象的独立性。</div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums">package ThreadLocal;

import java.util.Random;

public class ThreadLocalDemo implements Runnable {<br />
    //创建线程局部变量studentLocal，在后面你会发现用来保存Student对象<br />
    private final static ThreadLocal&lt;Student&gt; studentLocal = new ThreadLocal&lt;Student&gt;();

    public static void main(String[] agrs) {<br />
        ThreadLocalDemo td = new ThreadLocalDemo();<br />
        Thread t1 = new Thread(td, "a");<br />
        Thread t2 = new Thread(td, "b");<br />
        t1.start();<br />
        t2.start();<br />
    }

    public void run() {<br />
        accessStudent();<br />
    }

    /**<br />
     * 示例业务方法，用来测试<br />
     */<br />
    public void accessStudent() {<br />
        //获取当前线程的名字<br />
        String currentThreadName = Thread.currentThread().getName();<br />
        System.out.println(currentThreadName + " is running!");<br />
        //产生一个随机数并打印<br />
        Random random = new Random();<br />
        int age = random.nextInt(100);<br />
        System.out.println("thread " + currentThreadName + " set age to:" + age);<br />
        //获取一个Student对象，并将随机数年龄插入到对象属性中<br />
        Student student = getStudent();<br />
        student.setAge(age);<br />
        System.out.println("thread " + currentThreadName + " first read age is:" + student.getAge());<br />
        try {<br />
            Thread.sleep(500);<br />
        }<br />
        catch (InterruptedException ex) {<br />
            ex.printStackTrace();<br />
        }<br />
        System.out.println("thread " + currentThreadName + " second read age is:" + student.getAge());<br />
    }

    protected Student getStudent() {<br />
        //获取本地线程变量并强制转换为Student类型<br />
        Student student = studentLocal.get();<br />
        //线程首次执行此方法的时候，studentLocal.get()肯定为null<br />
        if (student == null) {<br />
            //创建一个Student对象，并保存到本地线程变量studentLocal中<br />
            student = new Student();<br />
            studentLocal.set(student);<br />
        }<br />
        return student;<br />
    }<br />
}</pre>
</div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>运行结果：</div>
<div>
<div>
<div>a is running!&nbsp;<br />thread a set age to:76&nbsp;<br />b is running!&nbsp;<br />thread b set age to:27&nbsp;<br />thread a first read age is:76&nbsp;<br />thread b first read age is:27&nbsp;<br />thread a second read age is:76&nbsp;<br />thread b second read age is:27&nbsp;</div>
</div>
</div>
<div>&nbsp;</div>
<div>可以看到a、b两个线程age在不同时刻打印的值是完全相同的。这个程序通过妙用ThreadLocal，既实现多线程并发，游兼顾数据的安全性。</div>
<div>&nbsp;</div>
<div><strong>四、总结</strong></div>
<div>&nbsp;</div>
<div>ThreadLocal使用场合主要解决多线程中数据数据因并发产生不一致问题。ThreadLocal为每个线程的中并发访问的数据提供一个副本，通过访问副本来运行业务，这样的结果是耗费了内存，单大大减少了线程同步所带来性能消耗，也减少了线程并发控制的复杂度。</div>
<div>&nbsp;</div>
<div>ThreadLocal不能使用原子类型，只能使用Object类型。ThreadLocal的使用比synchronized要简单得多。</div>
<div>&nbsp;</div>
<div>ThreadLocal和Synchonized都用于解决多线程并发访问。但是ThreadLocal与synchronized有本质的区别。synchronized是利用锁的机制，使变量或代码块在某一时该只能被一个线程访问。而ThreadLocal为每一个线程都提供了变量的副本，使得每个线程在某一时间访问到的并不是同一个对象，这样就隔离了多个线程对数据的数据共享。而Synchronized却正好相反，它用于在多个线程间通信时能够获得数据共享。</div>
<div>&nbsp;</div>
<div>Synchronized用于线程间的数据共享，而ThreadLocal则用于线程间的数据隔离。</div>
<div>&nbsp;</div>
<div>当然ThreadLocal并不能替代synchronized,它们处理不同的问题域。Synchronized用于实现同步机制，比ThreadLocal更加复杂。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div><strong>五、ThreadLocal使用的一般步骤</strong></div>
<div>&nbsp;</div>
<div>1、在多线程的类（如ThreadDemo类）中，创建一个ThreadLocal对象threadXxx，用来保存线程间需要隔离处理的对象xxx。</div>
<div>2、在ThreadDemo类中，创建一个获取要隔离访问的数据的方法getXxx()，在方法中判断，若ThreadLocal对象为null时候，应该new()一个隔离访问类型的对象，并强制转换为要应用的类型。</div>
<div>3、在ThreadDemo类的run()方法中，通过getXxx()方法获取要操作的数据，这样可以保证每个线程对应一个数据对象，在任何时刻都操作的是这个对象。</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kzv78j.html">Handler系列之使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8or6le8.html">CSS3 笔记一（Rounded Corners&sol;Border Images&sol;Backgrounds）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdgrge8.html">c&num;部分--- 一维数组放到集合中，在从集合中提取输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1vj6g8.html">eclipse中复制项目更名注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmx2j69.html">&lbrack;PS&rsqb; 透明底图片制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okpvl19.html">JAVA向文件中追加内容&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96on0my9.html">☀【Zepto】touch events</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4gnoq.html">sqlserver，执行生成脚本时&OpenCurlyDoubleQuote;引发类型为&OpenCurlyDoubleQuote;System&period;OutOfMemoryException&rdquo;的异常&rdquo;&lpar;已解决&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z37349.html">【转】对ARM堆栈的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zorjd1q.html">mysql root密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mek1k6q.html">OpenGL与CUDA互操作方式总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/90remj39.html">GetCheckProxy</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjnm779.html">Celery -- 分布式任务队列 及实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kjjwoq.html">39、ABTestingGateway</a>
		</li>
						<li><a href="https://www.batexi.com/a/902mlemq.html">用SLF4j&sol;Logback打印日志-2</a>
		</li>
						<li><a href="https://www.batexi.com/a/902dromq.html">2&period; Oracle体系结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2ky27oq.html">python 实现redis订阅发布功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gprkg49.html">Pod的创建过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1xjp09.html">触发Full GC执行的情况 以及其它补充信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kodvg7q.html">阿里云上部署了zabbix，突然无法收到报警邮件的解决办法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pjd02k9.html">Git-rebase与merge小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yzxreq.html">一个不错的vim配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vmw1o8.html">020&period; asp&period;net访问Excel文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okjxe59.html">部署 mozilla-BrowserQuest</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxndwpz8.html">MongoDB权限管理之用户名和密码的操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o0j6n9.html">【转】php利用mkdir创建多级目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w5wvvq.html">SwiftyJSON 中文介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1j1739.html">IE7中line-height垂直居中问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yjzx0q.html">Oracle Group by&plus;rollup&plus;cube 的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn2j20q.html">phonegap&ndash;app启动欢迎引导页localstorage</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
